<?php

class PrivateMessagePage extends Page {
	function requireDefaultRecords() {
		if(!DataObject::get("PrivateMessagePage")) {
			$page = new PrivateMessagePage();
			$page->Title = "Private Messages";
			$page->write();
			$page->doPublish();
		}
	}	
}

class PrivateMessagePage_Controller extends Page_Controller {
	function init() {
		if(!Member::currentUserID()) Security::permissionFailure();
		parent::init();
	}
	//returns all messages submitted to the logged in user.
	function MyMessages() {
		return DataObject::get("PrivateMessage", "ToID = " . Member::currentUserID());
	}
	
	function PostMessageForm() {
        //Nicknames of all members is passed into an array
		$members = DataObject::get("Member", "", "Nickname");
		$allMembers = array();
		foreach($members as $member) {
			$allMembers[$member->ID] = "$member->Nickname";
		}
		$me = Member::currentUser();
		return new Form($this, "PostMessageForm", new FieldSet(
			new ReadonlyField("From", "Von", "$me->Nickname"),
			new DropdownField("ToID", "Empfänger wählen:", $allMembers),
			new TextField("Subject", "Betreff"),
			new TextareaField("Body", "Text")
            
            ),
            new FieldSet(
                new FormAction("doPostMessage", "Absenden")
            ),
            //Required fields are named inside the array. Without subject messages can´t be red.
            new RequiredFields(array(Subject, Body))
        );
	}
    //A form that is appended when a single message is red.
    function ReplyMessageForm() {
		$me = Member::currentUser();
        $message = DataObject::get_by_id("PrivateMessage", $this->urlParams['ID']);
		return new Form($this, "PostMessageForm", new FieldSet(
			new HiddenField("ToID", "Empfänger", $message->ToID),
			new TextField("Subject", "Betreff", "Re: $message->Subject"),
			new TextareaField("Body", "Text")
            ),
            new FieldSet(
                new FormAction("doPostMessage", "Absenden")
            ),
            //Required fields are named inside the array. Without subject messages can´t be red.
            new RequiredFields(array(Subject, Body))
        );
	}
	//Save the input to the database
	function doPostMessage($data, $form) {
		$message = new PrivateMessage();
		$form->saveInto($message);
		$message->FromID = Member::currentUserID();
		$message->write();
		
		Director::redirect($this->Link());
	}
	//read the content of a single message. The ID of the message is passed via URL.
	function message() {
		$message = DataObject::get_by_id("PrivateMessage", $this->urlParams['ID']);
        //The message is only passed if the reader ist the receiver. Otherwise any message could be read by altering the id.
		if($message->ToID == Member::currentUserID()) {
			return array(
				'CurrentMessage' => $message			
			);
		} else {
			return array();
		}
	}
    //Deleting a single message
    function delete() {
        $message = DataObject::get_by_id("PrivateMessage", $this->urlParams['ID']);
        if($message){
            $message->delete();
            Director::redirect($this->Link());
        }
    }
	

}